"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const child_process_1 = require("child_process");
const config_1 = require("../config");
function default_1(def, buildDir, filename, memorySettings) {
    const wd = process.cwd();
    process.chdir(buildDir);
    const src = `${def.name}.wat`;
    const target = `${def.name}.wasm`;
    fs.writeFileSync(src, def.code);
    const call = `${config_1.WABT_TOOL.wat2wasm} ${src} && ${config_1.WABT_TOOL['wasm-strip']} ${target}`;
    (0, child_process_1.execSync)(call, { shell: config_1.SHELL, stdio: 'inherit' });
    return fs.readFileSync(target);
}
exports.default = default_1;
//# sourceMappingURL=wat.js.map