"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyMochaShim = void 0;
/**
 * Hack around mocha definitions for internal tests.
 *
 * This should not be used for general purpose testing with InWasm declarations,
 * instead place inline wasm definitions in separate module to be processed by
 * `inwasm` upfront, then test functionality in additional test modules.
 */
function applyMochaShim() {
    if (typeof describe === 'undefined') {
        global.describe = (s, f) => f();
    }
    if (typeof it === 'undefined') {
        global.it = (s, f) => f();
    }
}
exports.applyMochaShim = applyMochaShim;
//# sourceMappingURL=mocha_shim.js.map